import os, pygame
from pygame.locals import *

#functions to create our resources
def load_image(name, colorkey=None):
    fullname = os.path.join('Data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()

#classes for our game objects
class TopBar(pygame.sprite.Sprite):
    """Control your Ninja!"""
    def __init__(self, score, time, health, lives):
        pygame.sprite.Sprite.__init__(self) #call Sprite initializer
        self.image, self.rect = load_image('overlay1.gif')
        self.overlay, null = load_image('overlay1.gif')
        self.healthBar, self.healthBarRect = load_image('lifeBar.gif')
        self.gunIcon, null = load_image('gunIcon.gif')
        self.swordIcon, null = load_image('swordIcon.gif')
        self.score = score
        self.time = time
        self.health = health
        self.weapon = 0
        self.lives = lives
        self.blitAll()

    def update(self):
        "NOTHING"
        null = 0            

    def blitAll(self):
        self.image.blit(self.overlay, (0,0))
        
        font = pygame.font.Font(None, 24)
        scoreText = font.render(str(self.score), 1, (255, 255, 255))
        self.image.blit(scoreText, (75, 6))
        minute = self.time / 60
        second = self.time % 60
        minuteText = font.render("0"+str(minute)+":", 1, (255, 255, 255))
        if second < 10:
            secondText = font.render("0"+str(second), 1, (255, 255, 255))
        else:
            secondText = font.render(str(second), 1, (255, 255, 255))
        self.image.blit(minuteText, (230, 6))
        self.image.blit(secondText, (255, 6))
        currentHealth = 0
        if ( self.healthBarRect.width-(100-self.health) < 0 ):
            currentHealth = pygame.transform.scale(self.healthBar, (0, self.healthBarRect.height))
        else:
            currentHealth = pygame.transform.scale(self.healthBar, (self.healthBarRect.width-(100-self.health), self.healthBarRect.height))
        self.image.blit(currentHealth, (330, 10))
        if self.weapon == 1:
            self.image.blit(self.swordIcon, (523, 8))
        elif self.weapon == 0:
            self.image.blit(self.gunIcon, (523, 8))
        livesText = font.render(str(self.lives), 1, (255, 255, 255))
        self.image.blit(livesText, (620, 7))

    def setScore(self,score):
        self.score = score
        self.blitAll()
    
    def setTime(self, time):
        self.time = time
        self.blitAll()

    def setHealth(self, health):
        self.health = health
        self.blitAll()

    def setWeapon(self, weapon):
        self.weapon = weapon
        self.blitAll()

    def setLives(self, lives):
        self.lives = lives
        self.blitAll()
